/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 1997-2004 The PHP Group                                |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.0 of the PHP license,       |
  | that is bundled with this package in the file LICENSE, and is        |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_0.txt.                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author: Sterling Hughes <sterling@php.net>                           |
  +----------------------------------------------------------------------+
*/

/* $Id: php_mono.h,v 1.5 2004/01/08 17:32:26 sniper Exp $ */

#ifndef PHP_MONO_H
#define PHP_MONO_H

#include "php.h"
#include <mono/jit/jit.h>
#include <mono/metadata/loader.h>
#include <mono/metadata/class.h>
#include <mono/metadata/object.h>

extern zend_module_entry mono_module_entry;
#define phpext_mono_ptr &mono_module_entry

#ifdef PHP_WIN32
#define PHP_MONO_API __declspec(dllexport)
#else
#define PHP_MONO_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

typedef struct {
	zend_object zo;
	MonoClass *mclass;
	MonoObject *mobject;
	MonoImage *mimage;
} php_mono_object;

ZEND_BEGIN_MODULE_GLOBALS(mono)
	HashTable methods;
	HashTable classes;
	HashTable images;
ZEND_END_MODULE_GLOBALS(mono)

#ifdef ZTS
#define MONOG(v) TSRMG(mono_globals_id, zend_mono_globals *, v)
#else
#define MONOG(v) (mono_globals.v)
#endif

#endif


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * indent-tabs-mode: t
 * End:
 */
